var _NOISE = 140;
var _BLUR = 8;

title = getTitle();
Stack.setChannel(1);
roiManager("Reset");
run("Select None");
run("Duplicate...", "title=in");
run("Duplicate...", "title=filtered");
run("Gaussian Blur...", "sigma="+ _BLUR);
imageCalculator("Subtract create 32-bit", "in","filtered");
setAutoThreshold("MaxEntropy dark");
run("Find Maxima...", "noise="+_NOISE+" output=[Point Selection]");
roiManager("Add");
close();
close();
close();
roiManager("Show All");
roiManager("Select", 0);
waitForUser("Correct and press ok!");
roiManager("Select", 0);
getSelectionCoordinates(xp, yp);
run("Select None");
Stack.setChannel(2);
run("Duplicate...", "Nuclei");
setAutoThreshold("Huang dark");
run("Convert to Mask");
run("Watershed");
run("Analyze Particles...", "size=100-Infinity show=[Count Masks] exclude add");
roiManager("Select", 1);
getStatistics(area, mean, min);
first = min;
numberOfNuclei = roiManager("count")-1;
nuclei = newArray(numberOfNuclei);

for(i=0; i<xp.length; i++) {
	v = getPixel(xp[i], yp[i]);
	if (v>0) {
		nucleus = v-first;
		nuclei[nucleus] = nuclei[nucleus] + 1;
	}
}
close();
close();
table = "foci-count";
handle = "["+table+"]";
if (!isOpen(table)) {
 	run("Table...", "name="+handle+" width=800 height=600");
 	print(handle, "\\Headings:nucleus\timage\tnr_of_foci");
}
 	
for (i=0; i<numberOfNuclei; i++) {
	print(handle, (i+2) + "\t" + title + "\t" + nuclei[i]);
}
